<?php 
/**
* 实现从unicode到utf8的编码
*
* @version 1.0.0
* @package Charset
*/

class __unicode_utf8 extends CharsetTool  
{
	/**
	* 构造函数
	*
	* @access public
	*/
	function __construct()
	{
		parent::__construct();	
	}	

	/**
	* 转换编码
	*
	* @param string $string 要转换的字符串
	* @return string 转换的结果
	* @access public
	*/
	public function convert($string)
	{
	    $rs = "";
		$array = explode(";", $string);
		foreach ($array as $c)
		{
			$c = hexdec(str_replace("&#x", "", $c));
			$nc = "";
    		if ($c < 0x80) 
    		{
    			$nc .= $c;
    		}
    		else if ($c < 0x800) 
    		{
    			$nc .= (0xC0 | $c>>6);
    			$nc .= (0x80 | $c & 0x3F);
    		}
    		else if ($c < 0x10000) 
    		{
    			$nc .= (0xE0 | $c>>12);
    			$nc .= (0x80 | $c>>6 & 0x3F);
    			$nc .= (0x80 | $c & 0x3F);
    		}
    		else if ($c < 0x200000) 
    		{
    			$nc .= (0xF0 | $c>>18);
    			$nc .= (0x80 | $c>>12 & 0x3F);
    			$nc .= (0x80 | $c>>6 & 0x3F);
    			$nc .= (0x80 | $c & 0x3F);
    		}
    		
    		for($i=0; $i<strlen($nc); $i+=3)
			{
				$rs .= chr(substr($nc, $i, 3));
			}
		}
		
		return $rs;	
	}	
}


?>